/*
   Original Author: bbum

   Copyright 1999 by CodeFab, Inc.   All rights reserved.

   This notice may not be removed from this source code.
   The use and distribution of this software is governed by the
   terms of the MiscKit license agreement.  Refer to the license
   document included with the MiscKit distribution for the terms.
   Details of the license agreement may be found at
   www.misckit.com or within the MiscKit distribution.

   There may be more information about this software on
   www.codefab.com.  Send queries to ask_codefab@codefab.com.
*/

#import <WebObjects/WebObjects.h>
#import "NoisyNotificationCenter.h"

@implementation NoisyNotificationCenter
+ (void) load
{
    [NoisyNotificationCenter poseAsClass: [NSNotificationCenter class]];
}

- (void)postNotificationName:(NSString *)aName object:(id)anObject userInfo:(NSDictionary *)aUserInfo;
{
    NSAutoreleasePool *p = [[NSAutoreleasePool alloc] init];
    [WOApp logWithFormat: @"Posting %@, object '%@' (0x%X), userinfo keys %@", aName, [anObject class], anObject, [aUserInfo allKeys]];
    [p release];
    [super postNotificationName: aName object: anObject userInfo: aUserInfo];
}
@end
