/*
   Original Author: bbum

   Copyright 1999 by CodeFab, Inc.   All rights reserved.

   This notice may not be removed from this source code.
   The use and distribution of this software is governed by the
   terms of the MiscKit license agreement.  Refer to the license
   document included with the MiscKit distribution for the terms.
   Details of the license agreement may be found at
   www.misckit.com or within the MiscKit distribution.

   There may be more information about this software on
   www.codefab.com.  Send queries to ask_codefab@codefab.com.
*/

#import <WebObjects/WebObjects.h>
#import "Size.h"
#import "Size+BusinessLogic.h"

@implementation Size (BusinessLogic)
- (NSException *) validateVolume: (NSNumber *) aValue;
{
    // assume it is already a number of some kind-- formatter validation should enforce this.  In production code, either document the limitation or document the requirement for a formatter.
    int newValue;
    NSException *returnException;

    newValue = [aValue intValue];

    if (newValue == 0)
        returnException = [NSException validationExceptionWithFormat: @"Volume cannot be zero (Sierpinsky sponge not allowed)."];
    else if (newValue < 1)
        returnException = [NSException validationExceptionWithFormat: @"Volume cannot be negative (given our understanding of the universe)."];
    else
        returnException = nil;

    [WOApp logWithFormat: @"%@ - %@ %@ [%@] -> %@%@ %@", [self entityName], NSStringFromSelector(_cmd), aValue, [aValue class], returnException ? [returnException name] : @"<valid>", returnException ? @":" : @"", returnException ? [returnException reason] : @""];
    
    return returnException;
}

- (NSException *) validateNameOfSize:(NSString *)aValue;
{
    NSException *returnException;

    // again, we are assuming an NSString... this will be the case in a WOF app for any field that DOES NOT HAVE a numberformat, dateformat or formatter (that yields something other than NSString as its output)
    if ( (aValue == nil) || ([aValue isEqualToString: @""] == YES) || ([aValue length] == 0) )
        returnException = [NSException validationExceptionWithFormat: @"Must specify a Name for the Size."];
    else
        returnException = nil;

    [WOApp logWithFormat: @"%@ - %@ %@ [%@] -> %@%@ %@", [self entityName], NSStringFromSelector(_cmd), aValue, [aValue class], returnException ? [returnException name] : @"<valid>", returnException ? @":" : @"", returnException ? [returnException reason] : @""];

    return returnException;
}
@end
