/*
   Original Author: bbum

   Copyright 1999 by CodeFab, Inc.   All rights reserved.

   This notice may not be removed from this source code.
   The use and distribution of this software is governed by the
   terms of the MiscKit license agreement.  Refer to the license
   document included with the MiscKit distribution for the terms.
   Details of the license agreement may be found at
   www.misckit.com or within the MiscKit distribution.

   There may be more information about this software on
   www.codefab.com.  Send queries to ask_codefab@codefab.com.
*/
// Size.m
//
// Created on Tue Jul 13 10:08:57 US/Pacific 1999 by Apple EOModeler Version 378.2

#import <WebObjects/WebObjects.h>

#import "Size.h"


@implementation Size

// EditingContext-based archiving support.  Useful for WebObjects
// applications that store state in the page or in cookies.

- (void)encodeWithCoder:(NSCoder *)aCoder {
	[WOApp logWithFormat: @"Size - %@", NSStringFromSelector(_cmd)];
	[EOEditingContext encodeObject:self withCoder:aCoder];
}

- (id)initWithCoder:(NSCoder *)aDecoder {
	[WOApp logWithFormat: @"Size - %@", NSStringFromSelector(_cmd)];
	return [EOEditingContext initObject:self withCoder:aDecoder];
}

- (void)setNameOfSize:(NSString *)value
{
    [self willChange];
    [WOApp logWithFormat: @"Size - %@: %@ [%@] (was %@)", NSStringFromSelector(_cmd), value, [value class], nameOfSize];
    [nameOfSize autorelease];
    nameOfSize = [value retain];
}
- (NSString *)nameOfSize {
    [WOApp logWithFormat: @"Size - %@ (%@ [%@])", NSStringFromSelector(_cmd),  nameOfSize, [nameOfSize class]];
   return nameOfSize; }

- (void)setVolume:(NSNumber *)value
{
    [self willChange];
    [WOApp logWithFormat: @"Size - %@: %@ [%@] (was %@)", NSStringFromSelector(_cmd), value, [value class], volume];
    [volume autorelease];
    volume = [value retain];
}
- (NSNumber *)volume {
    [WOApp logWithFormat: @"Size - %@ (%@ [%@])", NSStringFromSelector(_cmd),  volume, [volume class]];
   return volume; }


- (void)dealloc
{
    [nameOfSize release];
    [volume release];
    
    [super dealloc];
}

- (id)validateTakeValue:(id)value forKeyPath:(NSString *)path;
{
    id returnValue;

    [WOApp logWithFormat: @"--> Size - %@ (path: %@) (value: %@ [%@])", NSStringFromSelector(_cmd), path, value, [value class]];

    NS_DURING
        returnValue = [super validateTakeValue: value forKeyPath: path];
    NS_HANDLER
        [WOApp logWithFormat: @"<-- Size - %@ (path: %@) Exception during validation: %@", NSStringFromSelector(_cmd), path, [localException reason]];
        [localException raise];
    NS_ENDHANDLER

    [WOApp logWithFormat: @"<-- Size - %@ (path: %@) coerced: %@ [%@]", NSStringFromSelector(_cmd), path, returnValue, [returnValue class]];

    return returnValue;
}
@end
