/*
   Original Author: bbum

   Copyright 1999 by CodeFab, Inc.   All rights reserved.

   This notice may not be removed from this source code.
   The use and distribution of this software is governed by the
   terms of the MiscKit license agreement.  Refer to the license
   document included with the MiscKit distribution for the terms.
   Details of the license agreement may be found at
   www.misckit.com or within the MiscKit distribution.

   There may be more information about this software on
   www.codefab.com.  Send queries to ask_codefab@codefab.com.
*/
// Thing.m
//
// Created on Tue Jul 13 10:09:00 US/Pacific 1999 by Apple EOModeler Version 378.2

#import <WebObjects/WebObjects.h>

#import "Thing.h"

#import "Size.h"

@implementation Thing

// EditingContext-based archiving support.  Useful for WebObjects
// applications that store state in the page or in cookies.

- (void)encodeWithCoder:(NSCoder *)aCoder {
	[WOApp logWithFormat: @"Thing - %@", NSStringFromSelector(_cmd)];
	[EOEditingContext encodeObject:self withCoder:aCoder];
}

- (id)initWithCoder:(NSCoder *)aDecoder {
	[WOApp logWithFormat: @"Thing - %@", NSStringFromSelector(_cmd)];
	return [EOEditingContext initObject:self withCoder:aDecoder];
}

- (void)setNameOfThing:(NSString *)value
{
    [self willChange];
    [WOApp logWithFormat: @"Thing - %@: %@ [%@] (was %@)", NSStringFromSelector(_cmd), value, [value class], nameOfThing];
    [nameOfThing autorelease];
    nameOfThing = [value retain];
}
- (NSString *)nameOfThing {
    [WOApp logWithFormat: @"Thing - %@ (%@ [%@])", NSStringFromSelector(_cmd),  nameOfThing, [nameOfThing class]];
   return nameOfThing; }

- (void)setSizeOfThing:(Size *)value
{
    // a to-one relationship
    [self willChange];
    [WOApp logWithFormat: @"Thing - %@: %@ (was %@)", NSStringFromSelector(_cmd), value, sizeOfThing];
    [sizeOfThing autorelease];
    sizeOfThing = [value retain];
}
- (Size *)sizeOfThing {
    [WOApp logWithFormat: @"Thing - (Size *) %@ (%@ [%@])", NSStringFromSelector(_cmd), sizeOfThing, [sizeOfThing class]];
    return sizeOfThing; }


- (void)dealloc
{
    [nameOfThing release];
    [sizeOfThing release];
    
    [super dealloc];
}

- (id)validateTakeValue:(id)value forKeyPath:(NSString *)path;
{
    id returnValue;

    [WOApp logWithFormat: @"--> Thing - %@ (path: %@) (value: %@ [%@])", NSStringFromSelector(_cmd), path, value, [value class]];

    NS_DURING
        returnValue = [super validateTakeValue: value forKeyPath: path];
    NS_HANDLER
        [WOApp logWithFormat: @"<-- Thing - %@ (path: %@) Exception during validation: %@", NSStringFromSelector(_cmd), path, [localException reason]];
        [localException raise];
    NS_ENDHANDLER

    [WOApp logWithFormat: @"<-- Thing - %@ (path: %@) coerced: %@ [%@]", NSStringFromSelector(_cmd), path, returnValue, [returnValue class]];

    return returnValue;
}
@end
